// LEDマトリクス64x32(RGB) for PIC32MX250F128B デモプログラム1、グラデーション、テキストスクロール

// System clock :48MHz  FRC with PLL (8/2*24/2)
// Peripheral clock :48MHz

// DEVCFG3
// USERID = No Setting
#pragma config PMDL1WAY = OFF           // Peripheral Module Disable Configuration (Allow multiple reconfigurations)
#pragma config IOL1WAY = OFF            // Peripheral Pin Select Configuration (Allow multiple reconfigurations)
#pragma config FUSBIDIO = OFF           // USB USID Selection (Controlled by Port Function)
#pragma config FVBUSONIO = OFF          // USB VBUS ON Selection (Controlled by Port Function)

// DEVCFG2
#pragma config FPLLIDIV = DIV_2         // PLL Input Divider (2x Divider)
#pragma config FPLLMUL = MUL_24         // PLL Multiplier (24x Multiplier)
#pragma config FPLLODIV = DIV_2         // System PLL Output Clock Divider (PLL Divide by 2)

// DEVCFG1
#pragma config FNOSC = FRCPLL           // Oscillator Selection Bits (Fast RC Osc with PLL)
#pragma config FSOSCEN = OFF            // Secondary Oscillator Enable (Disabled)
#pragma config IESO = OFF               // Internal/External Switch Over (Disabled)
#pragma config POSCMOD = OFF            // Primary Oscillator Configuration (Primary osc disabled)
#pragma config OSCIOFNC = OFF           // CLKO Output Signal Active on the OSCO Pin (Disabled)
#pragma config FPBDIV = DIV_1           // Peripheral Clock Divisor (Pb_Clk is Sys_Clk/1)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Clock Switch Disable, FSCM Disabled)
#pragma config WDTPS = PS1048576        // Watchdog Timer Postscaler (1:1048576)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable (Watchdog Timer is in Non-Window Mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (WDT Disabled (SWDTEN Bit Controls))
//#pragma config FWDTWINSZ = WINSZ_25     // Watchdog Timer Window Size (Window Size is 25%)

// DEVCFG0
#pragma config JTAGEN = OFF             // JTAG Enable (JTAG Disabled)
#pragma config ICESEL = ICS_PGx1        // ICE/ICD Comm Channel Select (Communicate on PGEC1/PGED1)
#pragma config PWP = OFF                // Program Flash Write Protect (Disable)
#pragma config BWP = OFF                // Boot Flash Write Protect bit (Protection Disabled)
#pragma config CP = OFF                 // Code Protect (Protection Disabled)

#include <xc.h>
#include <sys/attribs.h>
#include "led64x32-3.h"

void waitdraw(int n){
	drawcount=0;
	while(drawcount<n) asm("wait");
}
int main(void) {
	// Data Memory SRAM wait states: Default Setting = 1; set it to 0
	BMXCONbits.BMXWSDRM = 0; // SRAMのウェイトステートを0にする

	// Set the interrupt controller for multi-vector mode
	INTCONSET = _INTCON_MVEC_MASK; //割り込みをマルチベクタモードに設定

	// Set the CP0 Status IE bit to turn on interrupts globally
	__builtin_enable_interrupts(); //割り込み有効化

	// ピンの入出力設定（全て出力）
	TRISA = 0;
	TRISB = 0;
	ANSELA =0;
	ANSELB =0;
	ODCA = 0;
	ODCB = 0;

	init_led64x32();
	int i,j,n;
	int r,g,b;
	while(1){
		//グラデーション表示
		for(r=0;r<8;r++){
			for(g=0;g<16;g++){
				for(b=0;b<16;b++){
					pset((r%4)*16+b,(r/4)*16+g,r*2*256+g*16+b);
				}
			}
		}
		xferVRAM2VBUF();//VRAMからLEDバッファへ形式変換して転送
		waitdraw(600);//10秒ウェイト
		n=0;
		for(i=0;i<4;i++){
			for(j=0;j<8;j++){
				putfont(j*8,i*8,rand()&0xfff,n+'A');//フォント表示、色は乱数
				n++;
			}
		}
		xferVRAM2VBUF();//VRAMからLEDバッファへ形式変換して転送
		for(i=0;i<300;i++){
			drawcount=0;
			vscroll();//上にスクロール
			xferVRAM2VBUF();
			while(drawcount<2) asm("wait");//60分の2秒待ち
		}
	}
}
